#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <iostream.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>
#include "svgacc.h"


RasterBlock *tile[50];
RasterBlock *blkdata;
RasterBlock *tile2[50];

char TileSet;
char buf[80];
char tilefile[]="tiles2.pcx";


typedef struct {  //Map Tiles and Flags
	int tile,flags;
}	MapInfo;

MapInfo Map[50][50];  //declares a 50x50 array of mapinfo

void LoadPCX(void);
void GrabTiles(void);
void DefineMap(void);
void DrawMap(void);


void GrabTiles(char fname[]=tilefile) {
		pcxput(SET,1,1,fname);
		getch();
		int tiletemp;
		for(tiletemp=0;tiletemp<10;tiletemp++) {
			tile[tiletemp] = (RasterBlock *)malloc((18)*(18)+4);
			blkget(1+(18*tiletemp),1,18+(18*tiletemp),18,tile[tiletemp]);
			}
		for(tiletemp=0;tiletemp<10;tiletemp++) {
			tile2[tiletemp] = (RasterBlock *)malloc((25)*(25)+4);
			blkresize(25,25,tile[tiletemp],tile2[tiletemp]);
		}
};


void DrawMap(void) {
	int tempx;
	int tempy;
	int tempx2;
	int tempy2;
	fillscreen(BLACK);
	for(tempy=25;tempy<468;tempy+=25) {
		for(tempx=25;tempx<630;tempx+=25) {
			blkput(1,tempx-25,tempy-25,tile2[Map[(tempx/25)-1][(tempy/25)-1].tile]);
		}
	}
	getch();
};



//int DefineMap(char *filename) {  //Actual function
void DefineMap(void) {
/*
	FILE oFile;
	oFile=fopen(filename,"rb")));            //Open the file
	fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the struct
	fclose(oFile);
*/
//  How to redifine tile and flags
	int in,in2;
	randomize();
	for(in=0;in<35;in++){
		for(in2=0;in2<26;in2++){
			Map[in][in2].tile=int(random(5));
		}
	}
};

void LoadPCX(char fname[]=tilefile) {
	int xsize,ysize,numcol,ok;
	int i,darkcolor,britecolor,currcolor;
	PaletteData pcxpal;

	ok=pcxgetinfo(fname,&xsize,&ysize,&numcol,pcxpal);
	if(ok==1) {
		if(!res640())
			exit(1);
		darkcolor=0+0+0;
	}
	britecolor=63+63+63;
	for(i=0;i<255;i++) {
		pcxpal[i].r>>=2;
		pcxpal[i].g>>=2;
		pcxpal[i].b>>=2;
		currcolor=pcxpal[i].r + pcxpal[i].g + pcxpal[i].b;
		if(currcolor > darkcolor)
			darkcolor=currcolor;
		if(currcolor < britecolor)
			britecolor=currcolor;
	}
	palset(pcxpal,0,255);
	fillscreen(darkcolor);
	} else {
		printf("error in pcx file, error code: %d\n",ok);
	}
};
